@echo off
title c't RAID-Patcher
cls
echo ...................................................................
echo ... c't RAID-Patcher ................................. c't 3/05 ...
echo ... Windows XP SP2 / Windows 2000 SP4 .............................
echo ... Windows XP Media Center Edition .......... kav@ctmagazin.de ...
echo ...................................................................

echo.

rem ------ Admin-Rechte prfen -----------------------------------------
set isadmin=
call :checkAdmin
if not "%isadmin%"=="y" (
	echo.
	echo Sie bentigen Administratorrechte, um den Patch auszufhren
	goto :abbruch
)

rem ------ Dateien checken ---------------------------------------------

echo --- Systemdateien kopieren und berprfen ...
copy %windir%\system32\dmadmin.exe .\winfiles >nul
copy %windir%\system32\dmconfig.dll .\winfiles >nul
copy %windir%\system32\drivers\dmboot.sys .\winfiles >nul

rem --- dmadmin.exe: XP SP2, bereits gepatcht?
md5sum winfiles\dmadmin.exe | %systemroot%\system32\find "10aba25722860a5d9781397fe324654a" >nul
if not errorlevel 1 (
	echo dmadmin.exe: Windows XP SP2, Datei ist bereits gepatcht!
	goto abbruch
)

rem --- dmadmin.exe: XP SP2?
md5sum winfiles\dmadmin.exe | %systemroot%\system32\find "18eb1f4599b6304567efdaffe78877e9" >nul
if not errorlevel 1 (
	echo dmadmin.exe: XP SP2
	goto xpsp2
)

rem --- dmadmin.exe: W2K, bereits gepatcht?
md5sum winfiles\dmadmin.exe | %systemroot%\system32\find "d19b997f88a7232f208ac44982154f45" >nul
if not errorlevel 1 (
	echo dmadmin.exe: Windows 2000 SP4, Datei ist bereits gepatcht!
	goto abbruch
)

rem --- dmadmin.exe: W2K?
md5sum winfiles\dmadmin.exe | %systemroot%\system32\find "3a34589d062d2d9e54ef28e07df87638" >nul
if not errorlevel 1 (
	echo dmadmin.exe: Windows 2000 SP4
	goto w2ksp4
)

echo dmadmin.exe: Unbekannte Dateiversion
goto abbruch

rem ----- Windows XP Dateien prfen -----------------------------
:xpsp2
rem --- dmboot.sys: XP SP2?
md5sum winfiles\dmboot.sys | %systemroot%\system32\find "5789b83ba87fc84c3568cf86cacef8ce" >nul
if not errorlevel 1 (
	echo dboot.sys: XP SP2
) else (
	echo dmboot.sys: nicht XP SP2!
	goto fehler
)

rem --- dmconfig.dll: XP SP2?
md5sum winfiles\dmconfig.dll | %systemroot%\system32\find "f6ec5d05424529a0598bab5af86c74f6" >nul

if not errorlevel 1 (
	echo dmconfig.dll: XP SP2
) else (
	echo dmconfig.dll: nicht XPSP2!
	goto fehler 
)

rem ----- XP SP2 patchen
echo.
echo --- Patch ausf?hren

echo dmadmin.exe
bspatch winfiles\dmadmin.exe winfiles\patched\dmadmin.exe winfiles\dmadmin.exe_xp.diff
echo dmconfig.dll
bspatch winfiles\dmconfig.dll winfiles\patched\dmconfig.dll winfiles\dmconfig.dll_xp.diff
echo dmboot.sys
bspatch winfiles\dmboot.sys winfiles\patched\dmboot.sys winfiles\dmboot.sys_xp.diff
echo.

goto replace



rem ----- Windows 2000 Dateien prfen -----------------------------
:w2ksp4
rem --- dmboot.sys: W2K SP4?
md5sum winfiles\dmboot.sys | %systemroot%\system32\find "39fe7db78c703e7c0440a2b5c3bc1ac8" >nul
if not errorlevel 1 (
	echo dboot.sys: Windows 2000 SP4
	) else (
	echo dmboot.sys: nicht Windows 2000 SP4!
	goto fehler
)

rem --- dmconfig.dll: W2K SP4?
md5sum winfiles\dmconfig.dll | %systemroot%\system32\find "9dc72af3b44a8cc3854fddd7cd5713c9" >nul

if not errorlevel 1 (
	echo dmconfig.dll: Windows 2000 SP4
) else (
	echo dmconfig.dll: nicht Windows 2000 SP4!
	goto fehler 
)

rem ----- Windows 2000 SP4 patchen
echo.
echo --- Patch ausfhren

echo dmadmin.exe
bspatch winfiles\dmadmin.exe winfiles\patched\dmadmin.exe winfiles\dmadmin.exe_w2k.diff
echo dmconfig.dll
bspatch winfiles\dmconfig.dll winfiles\patched\dmconfig.dll winfiles\dmconfig.dll_w2k.diff
echo dmboot.sys
bspatch winfiles\dmboot.sys winfiles\patched\dmboot.sys winfiles\dmboot.sys_w2k.diff
echo.

:replace
echo Hinweis: Windows muss im abgesicherten Modus laufen, damit das Skript die
echo Systemdateien berschreiben kann.
echo.
set /p choice=Systemdateien ersetzen? [J/N]:

if /i '%choice%'=='J' GOTO weiter
goto abbruch

:weiter
rem --------------------------------------------------------------------
echo --- Dateien in dllcache und system32 kopieren

copy winfiles\patched\dmadmin.exe %windir%\system32\dllcache >nul
copy winfiles\patched\dmconfig.dll %windir%\system32\dllcache >nul
copy winfiles\patched\dmboot.sys %windir%\system32\dllcache >nul

copy winfiles\patched\dmadmin.exe %windir%\system32 >nul
copy winfiles\patched\dmconfig.dll %windir%\system32 >nul
copy winfiles\patched\dmboot.sys %windir%\system32\drivers >nul

echo.
echo Das Skript hat die Systemdateien ersetzt. In der
echo Datentrgerverwaltung sollten jetzt die die RAID-Optionen
echo freigeschaltet sein, sofern gengend freie dynamische Datentrger
echo vorhanden sind (fr RAID 5 mindestens drei).
echo.
echo Die Originaldateien sind im Verzeichnis winfiles gesichert.

:ende
echo.
echo.
echo --- fertig.
goto bye

rem ----- Funktion: Administratorrechte prfen ---------------------
:checkAdmin
net localgroup administratoren | more +6 | find /i "%username%" >nul
if not errorlevel 1 set isadmin=y
goto :eof

:fehler
echo.
echo Ein Fehler ist aufgetreten

:abbruch
echo --- abgebrochen
echo.

:bye
pause
